## node-yarnpkg 1.22.19+~cs24.27.18

=== debian/changelog ===
node-yarnpkg (1.22.19+~cs24.27.18-4) unstable; urgency=medium

  [ Konstantin Demin ]
  * Update commander patch

 -- Yadd <yadd@debian.org>  Sat, 16 Sep 2023 18:35:12 +0400

node-yarnpkg (1.22.19+~cs24.27.18-3) unstable; urgency=medium

  * Team upload

  [ Konstantin Demin ]
  * Update commander patch

  [ Yadd ]
  * Update lintian override info format in d/source/lintian-overrides
    on line 2-3, 5-8
  * Update standards version to 4.6.2, no changes needed

 -- Yadd <yadd@debian.org>  Wed, 13 Sep 2023 13:22:27 +0400

node-yarnpkg (1.22.19+~cs24.27.18-2) unstable; urgency=medium

  * Team upload
  * Update commander patch (Closes: #1019291)

 -- Yadd <yadd@debian.org>  Mon, 14 Nov 2022 05:22:50 +0100

node-yarnpkg (1.22.19+~cs24.27.18-1) unstable; urgency=medium

  * Team upload

  [ Yadd ]
  * Declare compliance with policy 4.6.1
  * New upstream version 1.22.19+~cs24.27.18

  [ Pirate Praveen ]
  * Drop build dependency on node-gulp-util (unused)

 -- Pirate Praveen <praveen@debian.org>  Thu, 12 May 2022 23:09:24 +0530

node-yarnpkg (1.22.10+~cs22.25.14-9) unstable; urgency=medium

  * Team upload
  * Drop useless build dependency to node-babel-eslint

 -- Yadd <yadd@debian.org>  Thu, 17 Mar 2022 08:19:36 +0100

=== debian/control ===
Source: node-yarnpkg
Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Paolo Greppi <paolo.greppi@libpf.com>
Section: javascript
Priority: optional
Build-Depends:
 debhelper-compat (= 13)
 , dh-sequence-nodejs
 , gulp (>= 4)
 , node-asap
 , node-babel-loader (>= 8.0~)
 , node-babel7
 , node-browserify-zlib
 , node-builtin-modules
 , node-bytes
 , node-ci-info
 , node-cli-table
 , node-death
 , node-deep-equal
 , node-detect-indent
 , node-emoji
 , node-execa
 , node-fancy-log
 , node-fast-levenshtein
 , node-gulp-babel (>= 8.0~)
 , node-gulp-newer
 , node-gulp-plumber
 , node-gulp-sourcemaps
 , node-inquirer
 , node-invariant
 , node-is-builtin-module
 , node-js-yaml (>= 3.13.1)
 , node-loader-utils
 , node-loud-rejection
 , node-marked-man
 , node-minimatch
 , node-object-path
 , node-prepend-http
 , node-proper-lockfile
 , node-puka
 , node-pumpify
 , node-read
 , node-request (>= 2.88.1-5~)
 , node-request-capture-har
 , node-resolve (>= 1.19.0+~cs5.20.8~)
 , node-schema-utils (>= 3.0.0)
 , node-sort-keys
 , node-strict-uri-encode
 , node-tar-stream
 , node-temp
 , node-through2
 , node-uuid
 , node-vinyl-fs (>= 3)
 , node-yargs
 , node-yn
 , webpack
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/js-team/node-yarnpkg
Vcs-Git: https://salsa.debian.org/js-team/node-yarnpkg.git
Homepage: https://github.com/yarnpkg/yarn
Rules-Requires-Root: no

Package: yarnpkg
Architecture: all
Depends:
 ${misc:Depends}
 , ca-certificates
 , node-asap
 , node-babel7-runtime
 , node-bytes
 , node-camelcase
 , node-chalk
 , node-chownr
 , node-ci-info
 , node-cli-table
 , node-commander (>= 7)
 , node-death
 , node-debug
 , node-deep-equal
 , node-detect-indent
 , node-duplexify
 , node-emoji
 , node-fast-levenshtein
 , node-glob
 , node-imports-loader
 , node-ini
 , node-inquirer
 , node-invariant
 , node-is-builtin-module
 , node-js-yaml (>= 3.13.1)
 , node-loud-rejection
 , node-micromatch
 , node-minimatch
 , node-mkdirp (>= 1.0~)
 , node-object-path
 , node-path-root
 , node-prepend-http
 , node-proper-lockfile
 , node-puka
 , node-pump
 , node-pumpify
 , node-read
 , node-request (>= 2.88.1-5~)
 , node-request-capture-har
 , node-resolve (>= 1.19.0+~cs5.20.8~)
 , node-rimraf
 , node-semver
 , node-sort-keys
 , node-ssri
 , node-strict-uri-encode
 , node-strip-ansi
 , node-strip-bom
 , node-tar-stream
 , node-through2
 , node-uuid
 , node-validate-npm-package-license
 , node-yn
 , nodejs:any
Provides:
 node-yarn
Description: Fast, reliable and secure npm alternative
 Fast: Yarnpkg caches every package it has downloaded, so it never
 needs to download the same package again. It also does almost
 everything concurrently to maximize resource utilization.
 This means even faster installs.
 .
 Reliable: Using a detailed but concise lockfile format and a
 deterministic algorithm for install operations, Yarnpkg is able
 to guarantee that any installation that works on one system will
 work exactly the same on another system.
 .
 Secure: Yarnpkg uses checksums to verify the integrity of every
 installed package before its code is executed.
 .
 Node.js is an event-based server-side JavaScript engine.

=== debian/watch ===
version=4

opts=\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-yarn-$1/ \
 https://github.com/yarnpkg/yarn/tags .*/archive/.*/v?([\d\.]+).tar.gz group

opts="searchmode=plain,ctype=nodejs,component=dnscache,pgpmode=none" \
 https://registry.npmjs.org/dnscache \
 https://registry.npmjs.org/dnscache/-/dnscache-(1[\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,ctype=nodejs,component=gunzip-maybe,pgpmode=none" \
 https://registry.npmjs.org/gunzip-maybe \
 https://registry.npmjs.org/gunzip-maybe/-/gunzip-maybe-(1[\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,ctype=nodejs,component=hash-for-dep,pgpmode=none" \
 https://registry.npmjs.org/hash-for-dep \
 https://registry.npmjs.org/hash-for-dep/-/hash-for-dep-(1[\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,ctype=nodejs,component=normalize-url,pgpmode=none" \
 https://registry.npmjs.org/normalize-url \
 https://registry.npmjs.org/normalize-url/-/normalize-url-(2[\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,ctype=nodejs,component=npm-logical-tree,pgpmode=none" \
 https://registry.npmjs.org/npm-logical-tree \
 https://registry.npmjs.org/npm-logical-tree/-/npm-logical-tree-(1[\d\.]+)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,ctype=nodejs,component=string-replace-loader,pgpmode=none" \
 https://registry.npmjs.org/string-replace-loader \
 https://registry.npmjs.org/string-replace-loader/-/string-replace-loader-(2[\d\.]+)@ARCHIVE_EXT@ checksum

# we cannot use ctype=nodejs here as we need a newer version than mentioned package.json
opts="searchmode=plain,pgpmode=none,component=tar-fs" \
 https://registry.npmjs.org/tar-fs \
 https://registry.npmjs.org/tar-fs/-/tar-fs-(2(?:.[\d\.]+)?)@ARCHIVE_EXT@ checksum

opts="searchmode=plain,ctype=nodejs,component=v8-compile-cache,pgpmode=none,\
" \
 https://registry.npmjs.org/v8-compile-cache \
 https://registry.npmjs.org/v8-compile-cache/-/v8-compile-cache-([\d\.]+)@ARCHIVE_EXT@ checksum

opts=\
component=mkdirp-classic,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-mkdirp-classic-$1/ \
 https://github.com/mafintosh/mkdirp-classic/tags .*/archive/.*/v?([\d\.]+).tar.gz checksum

# dependency of another component, normalize-url so ctype=nodejs won't work
opts="searchmode=plain,pgpmode=none,component=query-string" \
 https://registry.npmjs.org/query-string \
 https://registry.npmjs.org/query-string/-/query-string-(5(?:.[\d\.]+)?)@ARCHIVE_EXT@ checksum

# dependency of another component, gunzip-maybe so ctype=nodejs won't work
opts="searchmode=plain,pgpmode=none,component=is-deflate" \
 https://registry.npmjs.org/is-deflate \
 https://registry.npmjs.org/is-deflate/-/is-deflate-(1(?:.[\d\.]+)?)@ARCHIVE_EXT@ checksum

# dependency of another component, gunzip-maybe so ctype=nodejs won't work
opts="searchmode=plain,pgpmode=none,component=is-gzip" \
 https://registry.npmjs.org/is-gzip \
 https://registry.npmjs.org/is-gzip/-/is-gzip-(1(?:.[\d\.]+)?)@ARCHIVE_EXT@ checksum

## node-yarnpkg 4.0.2+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.1)
if(CMAKE_VERSION VERSION_LESS 3.12)
    cmake_policy(VERSION ${CMAKE_VERSION})
else()
    cmake_policy(VERSION 3.5.1...3.13.2)
endif()
message(STATUS "Using CMake version ${CMAKE_VERSION}")

# If not specified on the command line, enable C11 as the default
# Configuration items that affect the global compiler environment standards
# should be issued before the "project" command.
if(NOT CMAKE_C_STANDARD)
    set(CMAKE_C_STANDARD 11)          # The C standard whose features are requested to build this target
endif()
if(NOT CMAKE_C_STANDARD_REQUIRED)
    set(CMAKE_C_STANDARD_REQUIRED ON) # Boolean describing whether the value of C_STANDARD is a requirement
endif()
if(NOT CMAKE_C_EXTENSIONS)
    set(CMAKE_C_EXTENSIONS OFF)       # Boolean specifying whether compiler specific extensions are requested
endif()
set(VALID_C_STANDARDS "99" "11")
if(NOT CMAKE_C_STANDARD IN_LIST VALID_C_STANDARDS)
    MESSAGE(FATAL_ERROR "CMAKE_C_STANDARD:STRING=${CMAKE_C_STANDARD} not in known standards list\n ${VALID_C_STANDARDS}")
endif()

# Parse the full version number from zlib.h and include in ZLIB_FULL_VERSION
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/zlib${SUFFIX}.h.in _zlib_h_contents)
string(REGEX REPLACE ".*#define[ \t]+ZLIB_VERSION[ \t]+\"([0-9]+.[0-9]+.[0-9]+).*\".*"
        "\\1" ZLIB_HEADER_VERSION ${_zlib_h_contents})
string(REGEX REPLACE ".*#define[ \t]+ZLIBNG_VERSION[ \t]+\"([-0-9A-Za-z.]+)\".*"
        "\\1" ZLIBNG_HEADER_VERSION ${_zlib_h_contents})
message(STATUS "ZLIB_HEADER_VERSION: ${ZLIB_HEADER_VERSION}")
message(STATUS "ZLIBNG_HEADER_VERSION: ${ZLIBNG_HEADER_VERSION}")

project(zlib VERSION ${ZLIB_HEADER_VERSION} LANGUAGES C)

include(CheckTypeSize)
include(CheckSymbolExists)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckCCompilerFlag)
include(CMakeDependentOption)
include(FeatureSummary)

include(cmake/detect-arch.cmake)
include(cmake/detect-install-dirs.cmake)
include(cmake/detect-coverage.cmake)
include(cmake/detect-intrinsics.cmake)
include(cmake/detect-sanitizer.cmake)
include(cmake/fallback-macros.cmake)

if(CMAKE_TOOLCHAIN_FILE)
    message(STATUS "Using CMake toolchain: ${CMAKE_TOOLCHAIN_FILE}")
endif()

# Make sure we use an appropriate BUILD_TYPE by default, "Release" to be exact
# this should select the maximum generic optimisation on the current platform (i.e. -O3 for gcc/clang)
if(NOT GENERATOR_IS_MULTI_CONFIG)
    if(NOT CMAKE_BUILD_TYPE)
        set(CMAKE_BUILD_TYPE "Release" CACHE STRING
            "Choose the type of build, standard options are: Debug Release RelWithDebInfo MinSizeRel."
            FORCE)
        add_feature_info(CMAKE_BUILD_TYPE 1 "Build type: ${CMAKE_BUILD_TYPE} (default)")
    else()
        add_feature_info(CMAKE_BUILD_TYPE 1 "Build type: ${CMAKE_BUILD_TYPE} (selected)")
    endif()
endif()

#
# Options parsing
#
option(WITH_GZFILEOP "Compile with support for gzFile related functions" ON)
option(ZLIB_COMPAT "Compile with zlib compatible API" OFF)
option(ZLIB_ENABLE_TESTS "Build test binaries" ON)
option(ZLIBNG_ENABLE_TESTS "Test zlib-ng specific API" ON)
option(WITH_GTEST "Build gtest_zlib" ON)
option(WITH_FUZZERS "Build test/fuzz" OFF)
option(WITH_BENCHMARKS "Build test/benchmarks" OFF)
option(WITH_BENCHMARK_APPS "Build application benchmarks" OFF)
option(WITH_OPTIM "Build with optimisation" ON)
option(WITH_REDUCED_MEM "Reduced memory usage for special cases (reduces performance)" OFF)
option(WITH_NEW_STRATEGIES "Use new strategies" ON)
option(WITH_NATIVE_INSTRUCTIONS
    "Instruct the compiler to use the full instruction set on this host (gcc/clang -march=native)" OFF)
option(WITH_MAINTAINER_WARNINGS "Build with project maintainer warnings" OFF)
option(WITH_CODE_COVERAGE "Enable code coverage reporting" OFF)
option(WITH_INFLATE_STRICT "Build with strict inflate distance checking" OFF)
option(WITH_INFLATE_ALLOW_INVALID_DIST "Build with zero fill for inflate invalid distances" OFF)
option(WITH_UNALIGNED "Support unaligned reads on platforms that support it" ON)

set(ZLIB_SYMBOL_PREFIX "" CACHE STRING "Give this prefix to all publicly exported symbols.
Useful when embedding into a larger library.
Default is no prefix (empty prefix).")

# Add multi-choice option
set(WITH_SANITIZER AUTO CACHE STRING "Enable sanitizer support")
set_property(CACHE WITH_SANITIZER PROPERTY STRINGS "Memory" "Address" "Undefined" "Thread")

if(BASEARCH_ARM_FOUND)
    option(WITH_ACLE "Build with ACLE" ON)
    option(WITH_NEON "Build with NEON intrinsics" ON)
elseif(BASEARCH_PPC_FOUND)
    option(WITH_ALTIVEC "Build with AltiVec (VMX) optimisations for PowerPC" ON)
    option(WITH_POWER8 "Build with optimisations for POWER8" ON)
    option(WITH_POWER9 "Build with optimisations for POWER9" ON)
elseif(BASEARCH_RISCV_FOUND)
    option(WITH_RVV "Build with RVV intrinsics" ON)
elseif(BASEARCH_S360_FOUND)
    option(WITH_DFLTCC_DEFLATE "Build with DFLTCC intrinsics for compression on IBM Z" OFF)
    option(WITH_DFLTCC_INFLATE "Build with DFLTCC intrinsics for decompression on IBM Z" OFF)
    option(WITH_CRC32_VX "Build with vectorized CRC32 on IBM Z" ON)
elseif(BASEARCH_X86_FOUND)
    option(WITH_AVX2 "Build with AVX2" ON)
    option(WITH_AVX512 "Build with AVX512" ON)
    option(WITH_AVX512VNNI "Build with AVX512 VNNI extensions" ON)
    option(WITH_SSE2 "Build with SSE2" ON)
    option(WITH_SSSE3 "Build with SSSE3" ON)
    option(WITH_SSE42 "Build with SSE42" ON)
    option(WITH_PCLMULQDQ "Build with PCLMULQDQ" ON)
    option(WITH_VPCLMULQDQ "Build with VPCLMULQDQ" ON)
endif()

option(INSTALL_UTILS "Copy minigzip and minideflate during install" OFF)

mark_as_advanced(FORCE
    ZLIB_SYMBOL_PREFIX
    WITH_REDUCED_MEM
    WITH_ACLE WITH_NEON
    WITH_DFLTCC_DEFLATE
    WITH_DFLTCC_INFLATE
    WITH_CRC32_VX
    WITH_AVX2 WITH_SSE2
    WITH_SSSE3 WITH_SSE42
    WITH_PCLMULQDQ
    WITH_ALTIVEC
    WITH_POWER8
    WITH_POWER9
    WITH_RVV
    WITH_INFLATE_STRICT
    WITH_INFLATE_ALLOW_INVALID_DIST
    WITH_UNALIGNED
    INSTALL_UTILS
    )

if(ZLIB_COMPAT)
    add_definitions(-DZLIB_COMPAT)
    set(WITH_GZFILEOP ON)
    set(SUFFIX "")
    set(ZLIB_FULL_VERSION ${ZLIB_HEADER_VERSION}.zlib-ng)
else()
    set(SUFFIX "-ng")
    set(ZLIB_FULL_VERSION ${ZLIBNG_HEADER_VERSION})
endif()

if(WITH_GZFILEOP)
    add_definitions(-DWITH_GZFILEOP)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "^Intel")
    if(CMAKE_HOST_UNIX)
        set(WARNFLAGS -Wall)
        set(WARNFLAGS_MAINTAINER -Wall -Wcheck -Wremarks)
        set(WARNFLAGS_DISABLE)
    else()
        set(WARNFLAGS /Wall)
        set(WARNFLAGS_MAINTAINER /W5)
        set(WARNFLAGS_DISABLE)
    endif()
    if(WITH_NATIVE_INSTRUCTIONS)
        message(STATUS "Ignoring WITH_NATIVE_INSTRUCTIONS; not supported on this configuration")
        set(WITH_NATIVE_INSTRUCTIONS OFF)
    endif()
elseif(MSVC)
    # Minimum supported MSVC version is 1800 = Visual Studio 12.0/2013
    # See also https://cmake.org/cmake/help/latest/variable/MSVC_VERSION.html
    if(MSVC_VERSION VERSION_LESS 1800)
        message(SEND_ERROR "Unsupported Visual Studio compiler version (requires 2013 or later).")
    endif()
    # TODO. ICC can be used through MSVC. I'm not sure if we'd ever see that combination
    # (who'd use cmake from an IDE...) but checking for ICC before checking for MSVC should
    # avoid mistakes.
    # /Oi ?
    set(WARNFLAGS /W3)
    set(WARNFLAGS_MAINTAINER /W4)
    set(WARNFLAGS_DISABLE)
    if(BASEARCH_ARM_FOUND)
        add_definitions(-D_ARM_WINAPI_PARTITION_DESKTOP_SDK_AVAILABLE)
        if(NOT "${ARCH}" MATCHES "aarch64")
            set(NEONFLAG "/arch:VFPv4")
        endif()
        endif()
    if(WITH_NATIVE_INSTRUCTIONS)
        message(STATUS "Ignoring WITH_NATIVE_INSTRUCTIONS; not supported on this configuration")
        set(WITH_NATIVE_INSTRUCTIONS OFF)
    endif()
elseif(CMAKE_C_COMPILER_ID MATCHES "GNU" OR CMAKE_C_COMPILER_ID MATCHES "Clang")
    # Enable warnings in GCC and Clang
    set(WARNFLAGS -Wall)
    set(WARNFLAGS_MAINTAINER -Wextra)
    set(WARNFLAGS_DISABLE)
    if(WITH_NATIVE_INSTRUCTIONS)
        if(BASEARCH_PPC_FOUND)
            set(NATIVEFLAG "-mcpu=native")
        else()
            set(NATIVEFLAG "-march=native")
        endif()
    else()
        if(BASEARCH_ARM_FOUND)
            if("${ARCH}" MATCHES "arm" AND NOT CMAKE_C_FLAGS MATCHES "-mfloat-abi")
                # Auto-detect support for ARM floating point ABI
                set(CMAKE_REQUIRED_FLAGS -mfloat-abi=softfp)
                check_c_source_compiles(
                    "#include <features.h>
                    int main() { return 0; }"
                    HAVE_FLOATABI_SOFTFP)
                if(HAVE_FLOATABI_SOFTFP)
                    set(FLOATABI -mfloat-abi=softfp)
                else()
                    set(CMAKE_REQUIRED_FLAGS -mfloat-abi=hard)
                    check_c_source_compiles(
                        "#include <features.h>
                        int main() { return 0; }"
                        HAVE_FLOATABI_HARD)
                    if(HAVE_FLOATABI_HARD)
                        set(FLOATABI -mfloat-abi=hard)
                    endif()
                endif()
                set(CMAKE_REQUIRED_FLAGS)
                if(FLOATABI)
                    message(STATUS "ARM floating point arch: ${FLOATABI}")
                    add_compile_options(${FLOATABI})
                else()
                    message(STATUS "ARM floating point arch not auto-detected")
                endif()
            endif()
        endif()
        # Check whether -fno-lto is available
        set(CMAKE_REQUIRED_FLAGS "-fno-lto")
        check_c_source_compiles(
            "int main() { return 0; }"
            FNO_LTO_AVAILABLE FAIL_REGEX "not supported")
        set(CMAKE_REQUIRED_FLAGS)
        if(FNO_LTO_AVAILABLE)
            set(NOLTOFLAG "-fno-lto")
        endif()
    endif()
    if(MINGW)
        list(APPEND WARNFLAGS_DISABLE -Wno-pedantic-ms-format)
    endif()
else()
    if(WITH_NATIVE_INSTRUCTIONS)
        message(STATUS "Ignoring WITH_NATIVE_INSTRUCTIONS; not implemented yet on this configuration")
        set(WITH_NATIVE_INSTRUCTIONS OFF)
    endif()
endif()

# Disable LTO
if(NOT WITH_NATIVE_INSTRUCTIONS)
    set(CMAKE_INTERPROCEDURAL_OPTIMIZATION OFF)
    foreach(_cfg_name IN LISTS CMAKE_CONFIGURATION_TYPES)
        string(TOUPPER "${_cfg_name}" _cfg_name_uc)
        set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_${_cfg_name_uc} OFF)
    endforeach()
endif()

# Set architecture alignment requirements
if(NOT WITH_UNALIGNED)
    add_definitions(-DNO_UNALIGNED)
    message(STATUS "Unaligned reads manually disabled")
endif()

# Apply warning compiler flags
if(WITH_MAINTAINER_WARNINGS)
    add_compile_options(${WARNFLAGS} ${WARNFLAGS_MAINTAINER} ${WARNFLAGS_DISABLE})
else()
    add_compile_options(${WARNFLAGS} ${WARNFLAGS_DISABLE})
endif()

# Set code coverage compiler flags
if(WITH_CODE_COVERAGE)
    add_code_coverage()
endif()

# Replace optimization level 3 added by default with level 2
if(NOT WITH_CODE_COVERAGE AND NOT MSVC AND NOT CMAKE_C_FLAGS MATCHES "([\\/\\-]O)3")
    string(REGEX REPLACE "([\\/\\-]O)3" "\\12"
        CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
endif()

# Set native instruction set compiler flag
if(WITH_NATIVE_INSTRUCTIONS AND DEFINED NATIVEFLAG)
    # Apply flag to all source files and compilation checks
    add_compile_options(${NATIVEFLAG})
endif()

#
# Check for standard/system includes
#
check_include_file(sys/auxv.h  HAVE_SYS_AUXV_H)
if(HAVE_SYS_AUXV_H)
    add_definitions(-DHAVE_SYS_AUXV_H)
endif()
check_include_file(sys/sdt.h   HAVE_SYS_SDT_H)
if(HAVE_SYS_SDT_H)
    add_definitions(-DHAVE_SYS_SDT_H)
endif()
check_include_file(unistd.h    HAVE_UNISTD_H)

#
# Check to see if we have large file support
#
set(CMAKE_REQUIRED_DEFINITIONS -D_LARGEFILE64_SOURCE=1 -D__USE_LARGEFILE64)
check_type_size(off64_t OFF64_T)
if(HAVE_OFF64_T)

=== Makefile ===
CC=emcc

all: clean dir wasm asm

wasm:
	$(CC) yoga/yoga/*.cpp yoga/yoga/**/*.cpp yoga/javascript/src_native/*.cc \
		--bind \
		-Iyoga \
		-g0 \
		-O3 \
		-flto \
		-std=c++14 \
		-fno-exceptions \
		-fno-rtti \
		-DEMSCRIPTEN_HAS_UNBOUND_TYPE_NAMES=0 \
		--closure 1 \
		-s WASM=1 \
		-s WASM_ASYNC_COMPILATION=1 \
		-s USE_CLOSURE_COMPILER=1 \
		-s USE_ES6_IMPORT_META=0 \
		-s ASSERTIONS=0 \
		-s ALLOW_MEMORY_GROWTH=1 \
		-s MODULARIZE=1 \
		-s DYNAMIC_EXECUTION=0 \
		-s TEXTDECODER=0 \
		-s ENVIRONMENT='web' \
		-s FETCH_SUPPORT_INDEXEDDB=0 \
		-s FILESYSTEM=0 \
		-s MALLOC="emmalloc" \
		-s INCOMING_MODULE_JS_API=['instantiateWasm']\
		-s EXPORT_NAME="yoga" \
		-o tmp/yoga.mjs

asm:
	$(CC) yoga/yoga/*.cpp yoga/yoga/**/*.cpp yoga/javascript/src_native/*.cc \
		--bind \
		-Iyoga \
		-g0 \
		-Os \
		-flto \
		-std=c++14 \
		-fno-exceptions \
		-fno-rtti \
		-DEMSCRIPTEN_HAS_UNBOUND_TYPE_NAMES=0 \
		--closure 1 \
		--memory-init-file 0 \
		-s WASM=0 \
		-s WASM_ASYNC_COMPILATION=0 \
		-s USE_CLOSURE_COMPILER=1 \
		-s USE_ES6_IMPORT_META=0 \
		-s ASSERTIONS=0 \
		-s ALLOW_MEMORY_GROWTH=1 \
		-s MODULARIZE=1 \
		-s DYNAMIC_EXECUTION=0 \
		-s TEXTDECODER=0 \
		-s ENVIRONMENT='web' \
		-s FETCH_SUPPORT_INDEXEDDB=0 \
		-s FILESYSTEM=0 \
		-s MALLOC="emmalloc" \
		-s EXPORT_NAME="yoga" \
		-o tmp/yoga-asm.mjs

clean:
	rm -rf tmp 

dir:
	mkdir -p tmp

=== yoga/CMakeLists.txt ===
# Copyright (c) Meta Platforms, Inc. and affiliates.
#
# This source code is licensed under the MIT license found in the
# LICENSE file in the root directory of this source tree.


cmake_minimum_required(VERSION 3.13)
project(yogacore)
set(CMAKE_VERBOSE_MAKEFILE on)

if(TARGET yogacore)
    return()
endif()

include(CheckIPOSupported)

set(YOGA_ROOT ${CMAKE_CURRENT_SOURCE_DIR}/..)
include(${YOGA_ROOT}/cmake/project-defaults.cmake)


file(GLOB SOURCES CONFIGURE_DEPENDS
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/**/*.cpp)

add_library(yogacore STATIC ${SOURCES})

# Yoga conditionally uses <android/log> when building for Android
if (ANDROID)
    target_link_libraries(yogacore log)
endif()

check_ipo_supported(RESULT result)
if(result)
  set_target_properties(yogacore PROPERTIES
    CMAKE_INTERPROCEDURAL_OPTIMIZATION true)
endif()

target_include_directories(yogacore
    PUBLIC
    $<BUILD_INTERFACE:${YOGA_ROOT}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include/yoga>)

=== debian/changelog ===
node-yarnpkg (4.0.2+dfsg-2ubuntu1) oracular; urgency=medium

  * d/rules: add a few LDFLAGS flags to workaround a bug in the Debian
    Emscripten toolchain. Also remove some flags to avoid wasm-ld crashing
    (LP: #2068769).
  * d/p/fix-yarnpkg-libzip.patch: modify the patch so that it will not add
    in unsupported Node.js options that got removed and stablized in Node.js 20
  * d/p/disable-network-tests.patch: remove a test that requires Internet
    to run properly

 -- Zixing Liu <zixing.liu@canonical.com>  Mon, 17 Jun 2024 12:52:18 -0600

node-yarnpkg (4.0.2+dfsg-2) unstable; urgency=medium

  * Team upload
  * Upload to unstable

 -- Israel Galadima <izzygaladima@gmail.com>  Thu, 21 Dec 2023 22:10:51 +0100

node-yarnpkg (4.0.2+dfsg-1) experimental; urgency=medium

  * Team upload
  * Update README.Debian
  * New upstream version 4.0.2+dfsg
  * Build @yarnpkg/* packages
  * Install @yarnpkg/* packages and others
  * Update d/clean
  * Update d/control
  * Add require tests

 -- Israel Galadima <izzygaladima@gmail.com>  Sun, 10 Dec 2023 12:52:51 +0100

node-yarnpkg (4.0.1+dfsg-2) experimental; urgency=medium

  * Team upload
  * Disable flaky tests
  * Add debian/NEWS and debian/README.Debian
  * Add caveat to package description
  * Update uploaders field

 -- Israel Galadima <izzygaladima@gmail.com>  Sun, 29 Oct 2023 20:45:59 +0100

node-yarnpkg (4.0.1+dfsg-1) experimental; urgency=medium

  * Team upload
  * New upstream version 4.0.1+dfsg
  * Update version in manpage

 -- Israel Galadima <izzygaladima@gmail.com>  Sun, 29 Oct 2023 09:02:54 +0100

node-yarnpkg (4.0.0-rc.53+dfsg-1) experimental; urgency=medium

  * Team upload
  * Embed many components
  * New upstream version 4.0.0-rc.53+dfsg (Closes: #958686, #977667, #981919, #940704, #1000582, #1002902, #980316, #993566)
  * Remove old patches
  * Setup build
  * Add build_modules
  * Add test_modules
  * Add new patches
  * Clean build artifacts
  * Remove old files
  * Install docs and fix perms
  * Update upstream metadata
  * Update lintian overrides
  * Fix autopkgtest
  * Update links
  * Add manpage
  * Update description and dependencies

 -- Israel Galadima <izzygaladima@gmail.com>  Fri, 13 Oct 2023 09:42:42 +0100

=== debian/control ===
Source: node-yarnpkg
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Javascript Maintainers <pkg-javascript-devel@lists.alioth.debian.org>
Uploaders: Paolo Greppi <paolo.greppi@libpf.com>, Israel Galadima <izzygaladima@gmail.com>
Section: javascript
Priority: optional
Build-Depends: debhelper-compat (= 13)
 , dh-sequence-nodejs-no-lerna
 , dh-nodejs
 , cmake
 , node-fs-extra
 , node-clipanion
 , node-lodash-packages
 , node-typanion
 , node-enquirer
 , node-micromatch
 , node-ci-info
 , node-semver
 , node-react
 , node-diff
 , node-zkochan-cmd-shim
 , node-ssri
 , node-tar-stream
 , node-p-limit
 , node-camelcase
 , node-fast-glob
 , node-globby
 , node-cli-truncate
 , node-type-fest
 , node-cli-boxes
 , node-indent-string
 , node-widest-line
 , node-react-reconciler
 , node-string-width
 , node-cli-cursor
 , node-ansi-escapes
 , node-signal-exit
 , node-auto-bind
 , node-types-is-ci
 , node-is-upper-case
 , node-stack-utils
 , node-code-excerpt
 , node-ws
 , node-rollup-plugin-commonjs
 , node-rollup-plugin-node-resolve
 , node-lodash
 , node-is-fullwidth-code-point
 , node-ansi-styles
 , node-is-ci
 , node-slice-ansi
 , node-wrap-ansi
 , node-strip-ansi
 , node-got
 , node-tar
 , node-js-yaml
 , node-arg
 , ava <!nocheck>
 , ts-node
 , node-sinon <!nocheck>
 , node-boxen
 , jest <!nocheck>
 , mocha <!nocheck>
 , rollup
 , esbuild
 , node-rollup-pluginutils
 , node-typescript
 , emscripten
 , node-tap <!nocheck>
 , node-pirates
 , node-chalk
 , node-rollup-plugin-json
 , node-rollup-plugin-terser
 , node-tslib
 , node-babel7
 , node-rollup-plugin-babel
 , node-magic-string
 , node-estree-walker
 , node-acorn
 , node-rollup-plugin-typescript2
 , node-rollup-plugin-alias
 , node-csstype
 , node-prop-types
 , git
 , rsync
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/js-team/node-yarnpkg
Vcs-Git: https://salsa.debian.org/js-team/node-yarnpkg.git
Homepage: https://github.com/yarnpkg/berry
Rules-Requires-Root: no

Package: yarnpkg
Architecture: all
Depends: ${misc:Depends}
 , nodejs:any
 , git
 , node-tslib
 , node-clipanion
 , node-lodash
 , node-ci-info
 , node-enquirer
 , node-micromatch
 , node-semver
 , node-typanion
 , node-diff
 , node-react
 , node-zkochan-cmd-shim
 , node-ssri
 , node-tar-stream
 , node-p-limit
 , node-chalk
 , esbuild
 , node-camelcase
 , node-fast-glob
 , node-got
 , node-strip-ansi
 , node-tar
 , node-globby
 , node-typescript
 , node-js-yaml
 , node-ansi-styles
 , node-is-fullwidth-code-point
 , node-ansi-escapes
 , node-auto-bind
 , node-cli-boxes
 , node-cli-cursor
 , node-cli-truncate
 , node-code-excerpt
 , node-indent-string
 , node-is-ci
 , node-is-lower-case
 , node-is-upper-case
 , node-react-reconciler
 , node-scheduler
 , node-signal-exit
 , node-slice-ansi
 , node-stack-utils
 , node-string-width
 , node-type-fest
 , node-widest-line
 , node-wrap-ansi
 , node-ws
Provides: ${nodejs:Provides}
Description: Fast, reliable, and secure dependency management
 Yarn is a modern package manager split into various packages. Its novel
 architecture allows one to do things currently impossible with existing
 solutions:
  Yarn supports plugins; adding a plugin is as simple as adding it into your
  repository.
  Yarn supports Node by default but isn't limited to it - plugins can add
  support for other languages.
  Yarn supports workspaces natively, and its CLI takes advantage of that.
  Yarn uses a bash-like portable shell to make package scripts portable
  across of Windows, Linux, and macOS.
  Yarn is first and foremost a Node API that can be used programmatically
  (via @yarnpkg/core).
  Yarn is written in TypeScript and is fully type-checked.
 .
 This package provides Yarn Modern (berry). If you are looking for Yarn
 Classic (1.x), install node-corepack.
 .
 Node.js is an event-based server-side JavaScript engine.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_LDFLAGS_MAINT_STRIP  = -Wl,-Bsymbolic-functions
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--export-if-defined=main -Wl,--export-if-defined=__main_argc_argv

%:
	dh $@

override_dh_auto_build:
	dh_auto_build --buildsystem=nodejs_no_lerna
	set e
	for p in packages/*; do \
	  echo "Building $$p"; \
	  mkdir -p "$$p"/lib/; \
	  rsync -a --exclude '*.ts' --exclude '*.tsx' --include '*.d.ts' "$$p"/sources/ "$$p"/lib/; \
	  if [ "$$p" = "packages/yarnpkg-pnp" ]; then \
	    node scripts/compile.js "$$p" --emitDeclarationOnly; \
	  elif [ "$$p" = "packages/yarnpkg-libui" ]; then \
	    node scripts/compile.js "$$p" --inline; \
	  else \
	    node scripts/compile.js "$$p"; \
	  fi; \
	  echo "Built $$p"; \
	done

override_dh_auto_install:
	set e
	for p in packages/*; do \
	  debian/apply-publish-config "$$p"/package.json; \
	done
	dh_auto_install --buildsystem=nodejs_no_lerna --destdir=debian/yarnpkg/

override_dh_installdocs:
	dh_installdocs
	dh_nodejs_autodocs
	install -m 644 CODE_OF_CONDUCT.md CONTRIBUTING.md \
	GOVERNANCE.md HISTORY.md README.md SECURITY.md \
	debian/yarnpkg/usr/share/doc/node-yarnpkg-cli/

override_dh_fixperms:
	dh_fixperms
	chmod 755 debian/yarnpkg/usr/share/nodejs/@yarnpkg/cli/bundles/yarn.js

=== debian/watch ===
# yoga: should be manually downloaded at commit c09405d58c624fd26d5e0a7ed98bd10c5cc4c05b
# arcanis-libzip: should be manually downloaded at commit 664462465d2730d51f04437c90ed7ebcbe19a36f
# tinylogic: the downloaded tarball follows this naming pattern node-yarnpkg-tinylogic-git%Y%m%d.tar.xz

version=4
opts="mode=git,pgpmode=none,repack,repacksuffix=+dfsg,dversionmangle=auto" \
 https://github.com/yarnpkg/berry.git refs/tags/@yarnpkg/cli/@ANY_VERSION@

opts=\
component=dotenv,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-dotenv-$1/ \
 https://github.com/motdotla/dotenv/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts="mode=git,pgpmode=none,component=tinylogic,ctype=nodejs,dversionmangle=auto,pretty=tinylogic-git%cd" \
 https://github.com/arcanis/tinylogic.git HEAD ignore

opts=\
component=tau-prolog,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-tau-prolog-$1/ \
 https://github.com/tau-prolog/tau-prolog/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=readline-sync,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-readline-sync-$1/ \
 https://github.com/anseki/readline-sync/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=parse-url,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-parse-url-$1/ \
 https://github.com/IonicaBizau/parse-url/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=algoliasearch-client-javascript,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-algoliasearch-client-javascript-$1/ \
 https://github.com/algolia/algoliasearch-client-javascript/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=rollup-plugin-node-globals,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-rollup-plugin-node-globals-$1/ \
 https://github.com/calvinmetcalf/rollup-plugin-node-globals/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=ink,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-ink-$1/ \
 https://github.com/vadimdemedes/ink/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=ink-text-input,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-ink-text-input-$1/ \
 https://github.com/vadimdemedes/ink-text-input/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=patch-console,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-patch-console-$1/ \
 https://github.com/vadimdemedes/patch-console/tags .*/archive.*/v?([\d\.]+).tar.gz ignore

opts=\
component=yoga-wasm-web,\
ctype=nodejs,\
dversionmangle=auto,\
filenamemangle=s/.*?(\d[\d\.-]*@ARCHIVE_EXT@)/node-yoga-wasm-web-$1/ \
 https://github.com/shuding/yoga-wasm-web/tags .*/archive.*/v?([\d\.]+).tar.gz ignore
